/*
 * Docs Dispatcher API - API document(s) generation
 * Docs.io API enables you to generate files (currently DOCx, XLSx, PPTx, PDF, HTML, JPG/PNG/SVG) from a template and JSON data. You can just download resulting file, send email with generated attachments or compose services.
 *
 * The version of the OpenAPI document: 3.1.1
 * Contact: tech@docs-dispatcher.io
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package io.docs_dispatcher.client.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.docs_dispatcher.client.model.BasicRequest;
import io.docs_dispatcher.client.model.DeferredTargetRequest;
import io.docs_dispatcher.client.model.ESignField;
import io.docs_dispatcher.client.model.ESignFileContentRequest;
import io.docs_dispatcher.client.model.Recipient;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import org.openapitools.jackson.nullable.JsonNullable;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;
import com.google.gson.TypeAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import io.docs_dispatcher.client.JSON;

/**
 * ESignRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2024-03-23T16:40:16.535479755Z[Etc/UTC]", comments = "Generator version: 7.5.0-SNAPSHOT")
public class ESignRequest {
  public static final String SERIALIZED_NAME_PROVIDER = "provider";
  @SerializedName(SERIALIZED_NAME_PROVIDER)
  private String provider;

  public static final String SERIALIZED_NAME_SUBJECT = "subject";
  @SerializedName(SERIALIZED_NAME_SUBJECT)
  private String subject;

  public static final String SERIALIZED_NAME_MESSAGE_BODY = "messageBody";
  @SerializedName(SERIALIZED_NAME_MESSAGE_BODY)
  private String messageBody;

  public static final String SERIALIZED_NAME_MESSAGE = "message";
  @SerializedName(SERIALIZED_NAME_MESSAGE)
  private BasicRequest message;

  public static final String SERIALIZED_NAME_FINAL_DOC_MESSAGE_SUBJECT = "finalDocMessageSubject";
  @SerializedName(SERIALIZED_NAME_FINAL_DOC_MESSAGE_SUBJECT)
  private String finalDocMessageSubject;

  public static final String SERIALIZED_NAME_FINAL_DOC_MESSAGE_BODY = "finalDocMessageBody";
  @SerializedName(SERIALIZED_NAME_FINAL_DOC_MESSAGE_BODY)
  private String finalDocMessageBody;

  public static final String SERIALIZED_NAME_FINAL_DOC_MESSAGE = "finalDocMessage";
  @SerializedName(SERIALIZED_NAME_FINAL_DOC_MESSAGE)
  private BasicRequest finalDocMessage;

  public static final String SERIALIZED_NAME_RECIPIENTS = "recipients";
  @SerializedName(SERIALIZED_NAME_RECIPIENTS)
  private List<Recipient> recipients = new ArrayList<>();

  public static final String SERIALIZED_NAME_DOCUMENTS = "documents";
  @SerializedName(SERIALIZED_NAME_DOCUMENTS)
  private List<ESignFileContentRequest> documents = new ArrayList<>();

  public static final String SERIALIZED_NAME_FINAL_DOC_RECIPIENTS = "finalDocRecipients";
  @SerializedName(SERIALIZED_NAME_FINAL_DOC_RECIPIENTS)
  private List<Recipient> finalDocRecipients = new ArrayList<>();

  public static final String SERIALIZED_NAME_DATA = "data";
  @SerializedName(SERIALIZED_NAME_DATA)
  private Object data = null;

  /**
   * Gets or Sets type
   */
  @JsonAdapter(TypeEnum.Adapter.class)
  public enum TypeEnum {
    SIMPLE("SIMPLE"),
    
    CERTIFIED("CERTIFIED"),
    
    SMART("SMART"),
    
    ADVANCED("ADVANCED");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static TypeEnum fromValue(String value) {
      for (TypeEnum b : TypeEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<TypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final TypeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public TypeEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return TypeEnum.fromValue(value);
      }
    }

    public static void validateJsonElement(JsonElement jsonElement) throws IOException {
      String value = jsonElement.getAsString();
      TypeEnum.fromValue(value);
    }
  }

  public static final String SERIALIZED_NAME_TYPE = "type";
  @SerializedName(SERIALIZED_NAME_TYPE)
  private TypeEnum type;

  /**
   * Gets or Sets deliveryType
   */
  @JsonAdapter(DeliveryTypeEnum.Adapter.class)
  public enum DeliveryTypeEnum {
    EMAIL("EMAIL"),
    
    URL("URL"),
    
    SMS("SMS"),
    
    WEB("WEB");

    private String value;

    DeliveryTypeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static DeliveryTypeEnum fromValue(String value) {
      for (DeliveryTypeEnum b : DeliveryTypeEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<DeliveryTypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final DeliveryTypeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public DeliveryTypeEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return DeliveryTypeEnum.fromValue(value);
      }
    }

    public static void validateJsonElement(JsonElement jsonElement) throws IOException {
      String value = jsonElement.getAsString();
      DeliveryTypeEnum.fromValue(value);
    }
  }

  public static final String SERIALIZED_NAME_DELIVERY_TYPE = "deliveryType";
  @SerializedName(SERIALIZED_NAME_DELIVERY_TYPE)
  private DeliveryTypeEnum deliveryType;

  /**
   * Gets or Sets signingMode
   */
  @JsonAdapter(SigningModeEnum.Adapter.class)
  public enum SigningModeEnum {
    SEQUENTIAL("SEQUENTIAL"),
    
    PARALLEL("PARALLEL");

    private String value;

    SigningModeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static SigningModeEnum fromValue(String value) {
      for (SigningModeEnum b : SigningModeEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<SigningModeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final SigningModeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public SigningModeEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return SigningModeEnum.fromValue(value);
      }
    }

    public static void validateJsonElement(JsonElement jsonElement) throws IOException {
      String value = jsonElement.getAsString();
      SigningModeEnum.fromValue(value);
    }
  }

  public static final String SERIALIZED_NAME_SIGNING_MODE = "signingMode";
  @SerializedName(SERIALIZED_NAME_SIGNING_MODE)
  private SigningModeEnum signingMode;

  public static final String SERIALIZED_NAME_EXPIRATION_TIME = "expirationTime";
  @SerializedName(SERIALIZED_NAME_EXPIRATION_TIME)
  private Integer expirationTime;

  public static final String SERIALIZED_NAME_FIELDS = "fields";
  @SerializedName(SERIALIZED_NAME_FIELDS)
  private List<ESignField> fields = new ArrayList<>();

  public static final String SERIALIZED_NAME_SETTINGS = "settings";
  @SerializedName(SERIALIZED_NAME_SETTINGS)
  private Object settings;

  public static final String SERIALIZED_NAME_TARGETS = "targets";
  @SerializedName(SERIALIZED_NAME_TARGETS)
  private List<DeferredTargetRequest> targets = new ArrayList<>();

  public ESignRequest() {
  }

  public ESignRequest provider(String provider) {
    this.provider = provider;
    return this;
  }

   /**
   * Get provider
   * @return provider
  **/
  @javax.annotation.Nullable
  public String getProvider() {
    return provider;
  }

  public void setProvider(String provider) {
    this.provider = provider;
  }


  public ESignRequest subject(String subject) {
    this.subject = subject;
    return this;
  }

   /**
   * Get subject
   * @return subject
  **/
  @javax.annotation.Nullable
  public String getSubject() {
    return subject;
  }

  public void setSubject(String subject) {
    this.subject = subject;
  }


  public ESignRequest messageBody(String messageBody) {
    this.messageBody = messageBody;
    return this;
  }

   /**
   * Get messageBody
   * @return messageBody
  **/
  @javax.annotation.Nullable
  public String getMessageBody() {
    return messageBody;
  }

  public void setMessageBody(String messageBody) {
    this.messageBody = messageBody;
  }


  public ESignRequest message(BasicRequest message) {
    this.message = message;
    return this;
  }

   /**
   * Get message
   * @return message
  **/
  @javax.annotation.Nullable
  public BasicRequest getMessage() {
    return message;
  }

  public void setMessage(BasicRequest message) {
    this.message = message;
  }


  public ESignRequest finalDocMessageSubject(String finalDocMessageSubject) {
    this.finalDocMessageSubject = finalDocMessageSubject;
    return this;
  }

   /**
   * Get finalDocMessageSubject
   * @return finalDocMessageSubject
  **/
  @javax.annotation.Nullable
  public String getFinalDocMessageSubject() {
    return finalDocMessageSubject;
  }

  public void setFinalDocMessageSubject(String finalDocMessageSubject) {
    this.finalDocMessageSubject = finalDocMessageSubject;
  }


  public ESignRequest finalDocMessageBody(String finalDocMessageBody) {
    this.finalDocMessageBody = finalDocMessageBody;
    return this;
  }

   /**
   * Get finalDocMessageBody
   * @return finalDocMessageBody
  **/
  @javax.annotation.Nullable
  public String getFinalDocMessageBody() {
    return finalDocMessageBody;
  }

  public void setFinalDocMessageBody(String finalDocMessageBody) {
    this.finalDocMessageBody = finalDocMessageBody;
  }


  public ESignRequest finalDocMessage(BasicRequest finalDocMessage) {
    this.finalDocMessage = finalDocMessage;
    return this;
  }

   /**
   * Get finalDocMessage
   * @return finalDocMessage
  **/
  @javax.annotation.Nullable
  public BasicRequest getFinalDocMessage() {
    return finalDocMessage;
  }

  public void setFinalDocMessage(BasicRequest finalDocMessage) {
    this.finalDocMessage = finalDocMessage;
  }


  public ESignRequest recipients(List<Recipient> recipients) {
    this.recipients = recipients;
    return this;
  }

  public ESignRequest addRecipientsItem(Recipient recipientsItem) {
    if (this.recipients == null) {
      this.recipients = new ArrayList<>();
    }
    this.recipients.add(recipientsItem);
    return this;
  }

   /**
   * Get recipients
   * @return recipients
  **/
  @javax.annotation.Nullable
  public List<Recipient> getRecipients() {
    return recipients;
  }

  public void setRecipients(List<Recipient> recipients) {
    this.recipients = recipients;
  }


  public ESignRequest documents(List<ESignFileContentRequest> documents) {
    this.documents = documents;
    return this;
  }

  public ESignRequest addDocumentsItem(ESignFileContentRequest documentsItem) {
    if (this.documents == null) {
      this.documents = new ArrayList<>();
    }
    this.documents.add(documentsItem);
    return this;
  }

   /**
   * Get documents
   * @return documents
  **/
  @javax.annotation.Nullable
  public List<ESignFileContentRequest> getDocuments() {
    return documents;
  }

  public void setDocuments(List<ESignFileContentRequest> documents) {
    this.documents = documents;
  }


  public ESignRequest finalDocRecipients(List<Recipient> finalDocRecipients) {
    this.finalDocRecipients = finalDocRecipients;
    return this;
  }

  public ESignRequest addFinalDocRecipientsItem(Recipient finalDocRecipientsItem) {
    if (this.finalDocRecipients == null) {
      this.finalDocRecipients = new ArrayList<>();
    }
    this.finalDocRecipients.add(finalDocRecipientsItem);
    return this;
  }

   /**
   * Get finalDocRecipients
   * @return finalDocRecipients
  **/
  @javax.annotation.Nullable
  public List<Recipient> getFinalDocRecipients() {
    return finalDocRecipients;
  }

  public void setFinalDocRecipients(List<Recipient> finalDocRecipients) {
    this.finalDocRecipients = finalDocRecipients;
  }


  public ESignRequest data(Object data) {
    this.data = data;
    return this;
  }

   /**
   * Get data
   * @return data
  **/
  @javax.annotation.Nullable
  public Object getData() {
    return data;
  }

  public void setData(Object data) {
    this.data = data;
  }


  public ESignRequest type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * Get type
   * @return type
  **/
  @javax.annotation.Nullable
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }


  public ESignRequest deliveryType(DeliveryTypeEnum deliveryType) {
    this.deliveryType = deliveryType;
    return this;
  }

   /**
   * Get deliveryType
   * @return deliveryType
  **/
  @javax.annotation.Nullable
  public DeliveryTypeEnum getDeliveryType() {
    return deliveryType;
  }

  public void setDeliveryType(DeliveryTypeEnum deliveryType) {
    this.deliveryType = deliveryType;
  }


  public ESignRequest signingMode(SigningModeEnum signingMode) {
    this.signingMode = signingMode;
    return this;
  }

   /**
   * Get signingMode
   * @return signingMode
  **/
  @javax.annotation.Nullable
  public SigningModeEnum getSigningMode() {
    return signingMode;
  }

  public void setSigningMode(SigningModeEnum signingMode) {
    this.signingMode = signingMode;
  }


  public ESignRequest expirationTime(Integer expirationTime) {
    this.expirationTime = expirationTime;
    return this;
  }

   /**
   * Get expirationTime
   * @return expirationTime
  **/
  @javax.annotation.Nullable
  public Integer getExpirationTime() {
    return expirationTime;
  }

  public void setExpirationTime(Integer expirationTime) {
    this.expirationTime = expirationTime;
  }


  public ESignRequest fields(List<ESignField> fields) {
    this.fields = fields;
    return this;
  }

  public ESignRequest addFieldsItem(ESignField fieldsItem) {
    if (this.fields == null) {
      this.fields = new ArrayList<>();
    }
    this.fields.add(fieldsItem);
    return this;
  }

   /**
   * Get fields
   * @return fields
  **/
  @javax.annotation.Nullable
  public List<ESignField> getFields() {
    return fields;
  }

  public void setFields(List<ESignField> fields) {
    this.fields = fields;
  }


  public ESignRequest settings(Object settings) {
    this.settings = settings;
    return this;
  }

   /**
   * Get settings
   * @return settings
  **/
  @javax.annotation.Nullable
  public Object getSettings() {
    return settings;
  }

  public void setSettings(Object settings) {
    this.settings = settings;
  }


  public ESignRequest targets(List<DeferredTargetRequest> targets) {
    this.targets = targets;
    return this;
  }

  public ESignRequest addTargetsItem(DeferredTargetRequest targetsItem) {
    if (this.targets == null) {
      this.targets = new ArrayList<>();
    }
    this.targets.add(targetsItem);
    return this;
  }

   /**
   * Get targets
   * @return targets
  **/
  @javax.annotation.Nullable
  public List<DeferredTargetRequest> getTargets() {
    return targets;
  }

  public void setTargets(List<DeferredTargetRequest> targets) {
    this.targets = targets;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ESignRequest esignRequest = (ESignRequest) o;
    return Objects.equals(this.provider, esignRequest.provider) &&
        Objects.equals(this.subject, esignRequest.subject) &&
        Objects.equals(this.messageBody, esignRequest.messageBody) &&
        Objects.equals(this.message, esignRequest.message) &&
        Objects.equals(this.finalDocMessageSubject, esignRequest.finalDocMessageSubject) &&
        Objects.equals(this.finalDocMessageBody, esignRequest.finalDocMessageBody) &&
        Objects.equals(this.finalDocMessage, esignRequest.finalDocMessage) &&
        Objects.equals(this.recipients, esignRequest.recipients) &&
        Objects.equals(this.documents, esignRequest.documents) &&
        Objects.equals(this.finalDocRecipients, esignRequest.finalDocRecipients) &&
        Objects.equals(this.data, esignRequest.data) &&
        Objects.equals(this.type, esignRequest.type) &&
        Objects.equals(this.deliveryType, esignRequest.deliveryType) &&
        Objects.equals(this.signingMode, esignRequest.signingMode) &&
        Objects.equals(this.expirationTime, esignRequest.expirationTime) &&
        Objects.equals(this.fields, esignRequest.fields) &&
        Objects.equals(this.settings, esignRequest.settings) &&
        Objects.equals(this.targets, esignRequest.targets);
  }

  private static <T> boolean equalsNullable(JsonNullable<T> a, JsonNullable<T> b) {
    return a == b || (a != null && b != null && a.isPresent() && b.isPresent() && Objects.deepEquals(a.get(), b.get()));
  }

  @Override
  public int hashCode() {
    return Objects.hash(provider, subject, messageBody, message, finalDocMessageSubject, finalDocMessageBody, finalDocMessage, recipients, documents, finalDocRecipients, data, type, deliveryType, signingMode, expirationTime, fields, settings, targets);
  }

  private static <T> int hashCodeNullable(JsonNullable<T> a) {
    if (a == null) {
      return 1;
    }
    return a.isPresent() ? Arrays.deepHashCode(new Object[]{a.get()}) : 31;
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ESignRequest {\n");
    sb.append("    provider: ").append(toIndentedString(provider)).append("\n");
    sb.append("    subject: ").append(toIndentedString(subject)).append("\n");
    sb.append("    messageBody: ").append(toIndentedString(messageBody)).append("\n");
    sb.append("    message: ").append(toIndentedString(message)).append("\n");
    sb.append("    finalDocMessageSubject: ").append(toIndentedString(finalDocMessageSubject)).append("\n");
    sb.append("    finalDocMessageBody: ").append(toIndentedString(finalDocMessageBody)).append("\n");
    sb.append("    finalDocMessage: ").append(toIndentedString(finalDocMessage)).append("\n");
    sb.append("    recipients: ").append(toIndentedString(recipients)).append("\n");
    sb.append("    documents: ").append(toIndentedString(documents)).append("\n");
    sb.append("    finalDocRecipients: ").append(toIndentedString(finalDocRecipients)).append("\n");
    sb.append("    data: ").append(toIndentedString(data)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    deliveryType: ").append(toIndentedString(deliveryType)).append("\n");
    sb.append("    signingMode: ").append(toIndentedString(signingMode)).append("\n");
    sb.append("    expirationTime: ").append(toIndentedString(expirationTime)).append("\n");
    sb.append("    fields: ").append(toIndentedString(fields)).append("\n");
    sb.append("    settings: ").append(toIndentedString(settings)).append("\n");
    sb.append("    targets: ").append(toIndentedString(targets)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("provider");
    openapiFields.add("subject");
    openapiFields.add("messageBody");
    openapiFields.add("message");
    openapiFields.add("finalDocMessageSubject");
    openapiFields.add("finalDocMessageBody");
    openapiFields.add("finalDocMessage");
    openapiFields.add("recipients");
    openapiFields.add("documents");
    openapiFields.add("finalDocRecipients");
    openapiFields.add("data");
    openapiFields.add("type");
    openapiFields.add("deliveryType");
    openapiFields.add("signingMode");
    openapiFields.add("expirationTime");
    openapiFields.add("fields");
    openapiFields.add("settings");
    openapiFields.add("targets");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Element and throws an exception if issues found
  *
  * @param jsonElement JSON Element
  * @throws IOException if the JSON Element is invalid with respect to ESignRequest
  */
  public static void validateJsonElement(JsonElement jsonElement) throws IOException {
      if (jsonElement == null) {
        if (!ESignRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON element is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in ESignRequest is not found in the empty JSON string", ESignRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Map.Entry<String, JsonElement>> entries = jsonElement.getAsJsonObject().entrySet();
      // check to see if the JSON string contains additional fields
      for (Map.Entry<String, JsonElement> entry : entries) {
        if (!ESignRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `ESignRequest` properties. JSON: %s", entry.getKey(), jsonElement.toString()));
        }
      }
        JsonObject jsonObj = jsonElement.getAsJsonObject();
      if ((jsonObj.get("provider") != null && !jsonObj.get("provider").isJsonNull()) && !jsonObj.get("provider").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `provider` to be a primitive type in the JSON string but got `%s`", jsonObj.get("provider").toString()));
      }
      if ((jsonObj.get("subject") != null && !jsonObj.get("subject").isJsonNull()) && !jsonObj.get("subject").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `subject` to be a primitive type in the JSON string but got `%s`", jsonObj.get("subject").toString()));
      }
      if ((jsonObj.get("messageBody") != null && !jsonObj.get("messageBody").isJsonNull()) && !jsonObj.get("messageBody").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `messageBody` to be a primitive type in the JSON string but got `%s`", jsonObj.get("messageBody").toString()));
      }
      // validate the optional field `message`
      if (jsonObj.get("message") != null && !jsonObj.get("message").isJsonNull()) {
        BasicRequest.validateJsonElement(jsonObj.get("message"));
      }
      if ((jsonObj.get("finalDocMessageSubject") != null && !jsonObj.get("finalDocMessageSubject").isJsonNull()) && !jsonObj.get("finalDocMessageSubject").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `finalDocMessageSubject` to be a primitive type in the JSON string but got `%s`", jsonObj.get("finalDocMessageSubject").toString()));
      }
      if ((jsonObj.get("finalDocMessageBody") != null && !jsonObj.get("finalDocMessageBody").isJsonNull()) && !jsonObj.get("finalDocMessageBody").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `finalDocMessageBody` to be a primitive type in the JSON string but got `%s`", jsonObj.get("finalDocMessageBody").toString()));
      }
      // validate the optional field `finalDocMessage`
      if (jsonObj.get("finalDocMessage") != null && !jsonObj.get("finalDocMessage").isJsonNull()) {
        BasicRequest.validateJsonElement(jsonObj.get("finalDocMessage"));
      }
      if (jsonObj.get("recipients") != null && !jsonObj.get("recipients").isJsonNull()) {
        JsonArray jsonArrayrecipients = jsonObj.getAsJsonArray("recipients");
        if (jsonArrayrecipients != null) {
          // ensure the json data is an array
          if (!jsonObj.get("recipients").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `recipients` to be an array in the JSON string but got `%s`", jsonObj.get("recipients").toString()));
          }

          // validate the optional field `recipients` (array)
          for (int i = 0; i < jsonArrayrecipients.size(); i++) {
            Recipient.validateJsonElement(jsonArrayrecipients.get(i));
          };
        }
      }
      if (jsonObj.get("documents") != null && !jsonObj.get("documents").isJsonNull()) {
        JsonArray jsonArraydocuments = jsonObj.getAsJsonArray("documents");
        if (jsonArraydocuments != null) {
          // ensure the json data is an array
          if (!jsonObj.get("documents").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `documents` to be an array in the JSON string but got `%s`", jsonObj.get("documents").toString()));
          }

          // validate the optional field `documents` (array)
          for (int i = 0; i < jsonArraydocuments.size(); i++) {
            ESignFileContentRequest.validateJsonElement(jsonArraydocuments.get(i));
          };
        }
      }
      if (jsonObj.get("finalDocRecipients") != null && !jsonObj.get("finalDocRecipients").isJsonNull()) {
        JsonArray jsonArrayfinalDocRecipients = jsonObj.getAsJsonArray("finalDocRecipients");
        if (jsonArrayfinalDocRecipients != null) {
          // ensure the json data is an array
          if (!jsonObj.get("finalDocRecipients").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `finalDocRecipients` to be an array in the JSON string but got `%s`", jsonObj.get("finalDocRecipients").toString()));
          }

          // validate the optional field `finalDocRecipients` (array)
          for (int i = 0; i < jsonArrayfinalDocRecipients.size(); i++) {
            Recipient.validateJsonElement(jsonArrayfinalDocRecipients.get(i));
          };
        }
      }
      if ((jsonObj.get("type") != null && !jsonObj.get("type").isJsonNull()) && !jsonObj.get("type").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `type` to be a primitive type in the JSON string but got `%s`", jsonObj.get("type").toString()));
      }
      // validate the optional field `type`
      if (jsonObj.get("type") != null && !jsonObj.get("type").isJsonNull()) {
        TypeEnum.validateJsonElement(jsonObj.get("type"));
      }
      if ((jsonObj.get("deliveryType") != null && !jsonObj.get("deliveryType").isJsonNull()) && !jsonObj.get("deliveryType").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `deliveryType` to be a primitive type in the JSON string but got `%s`", jsonObj.get("deliveryType").toString()));
      }
      // validate the optional field `deliveryType`
      if (jsonObj.get("deliveryType") != null && !jsonObj.get("deliveryType").isJsonNull()) {
        DeliveryTypeEnum.validateJsonElement(jsonObj.get("deliveryType"));
      }
      if ((jsonObj.get("signingMode") != null && !jsonObj.get("signingMode").isJsonNull()) && !jsonObj.get("signingMode").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `signingMode` to be a primitive type in the JSON string but got `%s`", jsonObj.get("signingMode").toString()));
      }
      // validate the optional field `signingMode`
      if (jsonObj.get("signingMode") != null && !jsonObj.get("signingMode").isJsonNull()) {
        SigningModeEnum.validateJsonElement(jsonObj.get("signingMode"));
      }
      if (jsonObj.get("fields") != null && !jsonObj.get("fields").isJsonNull()) {
        JsonArray jsonArrayfields = jsonObj.getAsJsonArray("fields");
        if (jsonArrayfields != null) {
          // ensure the json data is an array
          if (!jsonObj.get("fields").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `fields` to be an array in the JSON string but got `%s`", jsonObj.get("fields").toString()));
          }

          // validate the optional field `fields` (array)
          for (int i = 0; i < jsonArrayfields.size(); i++) {
            ESignField.validateJsonElement(jsonArrayfields.get(i));
          };
        }
      }
      if (jsonObj.get("targets") != null && !jsonObj.get("targets").isJsonNull()) {
        JsonArray jsonArraytargets = jsonObj.getAsJsonArray("targets");
        if (jsonArraytargets != null) {
          // ensure the json data is an array
          if (!jsonObj.get("targets").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `targets` to be an array in the JSON string but got `%s`", jsonObj.get("targets").toString()));
          }

          // validate the optional field `targets` (array)
          for (int i = 0; i < jsonArraytargets.size(); i++) {
            DeferredTargetRequest.validateJsonElement(jsonArraytargets.get(i));
          };
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!ESignRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'ESignRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<ESignRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(ESignRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<ESignRequest>() {
           @Override
           public void write(JsonWriter out, ESignRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public ESignRequest read(JsonReader in) throws IOException {
             JsonElement jsonElement = elementAdapter.read(in);
             validateJsonElement(jsonElement);
             return thisAdapter.fromJsonTree(jsonElement);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of ESignRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of ESignRequest
  * @throws IOException if the JSON string is invalid with respect to ESignRequest
  */
  public static ESignRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, ESignRequest.class);
  }

 /**
  * Convert an instance of ESignRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

